/*
 * a-tools.h:
 */


#ifndef __A_TOOLS_H
#define __A_TOOLS_H

#include <stdio.h>
#include <stdlib.h>

#define FREE(x) if (x) {free(x);   x = NULL;}
#define DELETE(x) if (x) {delete x;  x = NULL;}
#define DELETEA(x) if (x) {delete[] x; x = NULL;}
#define FCLOSE(x) if (x) {fclose(x); x = NULL;}

#define KB(x) x * 1024
#define MB(x) KB(x) * 1024

typedef unsigned char uchar;

typedef struct abuffer {
        uchar *data;
        int length;
        int offset;
} abuffer;


char *strsub(char *s, int p, int numbers);

char *strcol(char *s, char *d, int c);

int strnumcol(char *s, char *d);

char *strgrep(char *s, FILE *f);

int strcmp0(char *s1, char *s2);

char *strdup0(char *s);
char *strdup0(const char *s);

void strtr(char *s);

#endif /* __A_TOOLS_H */
